/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ C_2_HTML.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE C du module de conversion \\\\\\\\\\\\\\\\*/
/*                    d'un source color en HTML color                */
/*                                                                     */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*..................... INCLUDES DES AUTRES MODULES DU PROGRAMME ......*/
#include <EAZY_GEM.H>  /* inclure les definitions des fonctions que le */
                       /* que le module EAZY_GEM.C met  notre         */
                       /* notre disposition                            */
                       /* et inclure les definitions des variables     */
                       /* globales  EAZY_GEM                           */
#include "EZ_EDIT.H"  /* routines d'affichage et de gestion du texte.  */

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#define  CFG_ADD_VIRG      1
#define  CFG_ADD_COMMENT   2
#define  CFG_ADD_CRLF      4

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

int    C_to_HTML(char* path, char* nom, TXTED_OB* TXT_A, TXT_GFG* ptTxtCfg, char* source);
int    PrintHTMLColorLigne(FILE* fh, long i, TXTED_OB *TXT_A, TXT_GFG *ptTxtCfg);
int    PrintHTMLColorBaliseTxt(FILE* fh, char *PtTexteLigne, TXTED_OB *TXT_A);
char*  CarToHTML_str(char* pt);
int    WriteAttributsTxtTAG(FILE* fh, CAR_ATTR*  attCur);
void   FwriteStr(FILE* fh, char *str);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/


/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*--------------------------------- C_to_HTML -------------------------*/
int C_to_HTML(char* path, char* nom, TXTED_OB* TXT_A, TXT_GFG* ptTxtCfg, char* source)
{char  file[MAX_PATH];
 FILE*  fh       = fopen( PathName_Concat(file, path, nom) , "wb");
 long   der_lgn  = TXT_A->NbLgn;
 long i          = 0;
 if (fh==0)      return 0;
 /*.............. voila !! ...............................*/
 FwriteStr(fh, "<!-- \r\n ............... Code Source converti par EZ_EDIT.PRG ....................... \r\n");
 FwriteStr(fh, "      Auteur: Roland SEVIN\r\n");
 FwriteStr(fh, "      http://www.multimania.com/eazygem/index.htm\r\n");
 FwriteStr(fh, "      Fichier Source: ");
 FwriteStr(fh, source);
 FwriteStr(fh, "\r\n-->\r\n");
 
 /*.................. balises pour texte non proportionnel ...........*/
 FwriteStr(fh, "<tt>\r\n");
 FwriteStr(fh, "<pre>\r\n");
 /*.................. affichage de toutes les lignes ..................*/
 for (i=0; i<der_lgn; i++)
     {PrintHTMLColorLigne(fh, i, TXT_A, ptTxtCfg);
     }
 /*................. balises de fin ...................................*/
 FwriteStr(fh, "</pre>\r\n</tt>\r\n<!-- ............... End of: ");
 FwriteStr(fh, source);
 FwriteStr(fh, " ................ -->\r\n");
 
 fclose( fh );
 return 1;

}

/*------------------------------ PrintHTMLColorLigne -------------------*/
int PrintHTMLColorLigne(FILE* fh, long i, TXTED_OB *TXT_A, TXT_GFG *ptTxtCfg)
{
#pragma warn -pia   /* Possible incorrect assignment. */
 char *affi_buff     = TXT_A->AffiBuff;
 char *pt_dst        = affi_buff;
 char *pt_src        = TXT_A->TabLgnCtx[i].ptTxt;
 LGN_STAT* lgn_stat  = (LGN_STAT*)TXT_A->SupLgnCtxtMem;
 int  isInSection    = 0;
 int  isInkwSection  = 0;
 int    tab          = TXT_A->ExpTAB;
 int    pos          = 0;
 int    idgrclass    = 0;
 int    nb_car       = 0;
 int   intGrClass    = 0;
 /*...... relever parametres de syntaxe colore associe  ce texte ........*/
 SYNT_PARAM *syntprm   = ptTxtCfg->SyntPrm;
 KWSECTION  *kwsection;
 char *beg_tab;
 char *end_tab;
 char *kwbeg_tab;
 char *kwend_tab;
 char *validTab;

 /*............ Si edition active et affi de la ligne en edition ...........*/
 if ( i == TXT_A->LigPt )
    {pt_src = TXT_A->BuffEdit;            /* on affiche le buffer de saisie */
    }
 else
    {pt_src = TXT_A->TabLgnCtx[i].ptTxt;  /* on affiche le texte normal     */
    }
 
 /*.............. Si numero de ligne positionn ............................*/
 if (TXT_A->ATT_Def[ATT_TXT_NUM_LGN].CarCol>-1)
    {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NUM_LGN];
     PrintHTMLColorBaliseTxt(fh, ltoa(i, "                                ", 10), TXT_A) ;
    }
 /*................ SI pas de syntaxe colore imprimer en monochrome .......*/
 /**/
 if (syntprm==0)
    {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NORMAL];
     while (*pt_src && *pt_src != 13 && *pt_src != 10)
           {if (*pt_src == '\t')
               {int fill = tab - (pos % tab);
                while (fill--) *pt_dst++ = ' ';
                pos += tab - (pos % tab);
                if (TXT_A->State & EDIT_TAB_VISIBLE && pt_dst[-tab]==' ')
                   {pt_dst[-tab] = TXT_A->CharTAB;
                   } 
                pt_src++;
               }
            else 
               {*pt_dst++ = *pt_src++;
                pos++;
               }
           } /*endwhile (*pt_src && *pt_src != 13 && *pt_src != 10) */
     *pt_dst   = 0;
     PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
     FwriteStr(fh, "\r\n");
     return 1;
    }
 /*................. SINON imprimer en couleur .............................*/
 /**/
 kwbeg_tab         = syntprm->KwSectBegFirstCar;
 kwend_tab         = syntprm->KwSectEndFirstCar;
 /* tx += TXT_A->MargLeft * DrvInf[DrvSel].PpiX / 91;Prt_Intl */
 
 /*....... relever etat de la ligne .......................................*/
 if (i) 
    {isInSection   = lgn_stat[i-1].LgnState;
     isInkwSection = lgn_stat[i-1].KwSection;
    }
 /*............ initialisation des variables ...............................*/
 kwsection         = &syntprm->KwSection[isInkwSection];
 intGrClass        = kwsection->IntGrClass;
 if       (isInSection)  TXT_A->ATT_Cur = kwsection->SectionAdr[isInSection].CarAtt;
 else                    TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
 validTab          = kwsection->ValidChar;
 beg_tab           = kwsection->BegSection;
 end_tab           = kwsection->EndSection;

 /*............ analyser la ligne ..........................................*/    
 while (*pt_src && *pt_src != 13 && *pt_src != 10)
  { /* TABULATION */
   if (*pt_src == '\t')
      {int fill = tab - (pos % tab);
       while (fill--) *pt_dst++ = ' ';
       pos += tab - (pos % tab);
       if (TXT_A->State & EDIT_TAB_VISIBLE && pt_dst[-tab]==' ')
          {pt_dst[-tab] = TXT_A->CharTAB;
          } 
       pt_src++;
      }
    /* END SECTION */
   else if (isInSection )
      {if ( end_tab[*pt_src] &&
           (nb_car = IsEndSection(pt_src, &isInSection, isInkwSection, syntprm)) 
          )
          {/*........ afficher le texte avant ..........*/
           FAST_CHARNCPY(pt_src, pt_dst, nb_car); /* met le zero de fin */
           PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           pt_src        += nb_car;
           pos           += nb_car;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
       else
          {*pt_dst++      = *pt_src++;
           pos++;
          }
      }
   else
      /* NUMERIC */
      {if (kwsection->NumCarBeg[*pt_src]                         &&
           BeforeIsValid(pt_src, i, kwsection->NumCar, TXT_A)
          )
          {nb_car = (int)IS_NUMERIC(pt_src+1, kwsection->NumCar);
           /*........ afficher le texte avant ..........*/
           *pt_dst        = 0;
           PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
           /*...... recuperer attribut graphique de la valeur numerique ...*/
           if (kwsection->NumBegGrClass!=kwsection->NumGrClass)
              {*affi_buff     = *pt_src;
               affi_buff[1]   = 0;
               TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumBegGrClass].AttGr;
               PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
               if (nb_car)
                  {FAST_CHARNCPY(pt_src+1, affi_buff, nb_car);
                   TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumGrClass].AttGr;
                   PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
                  }
              }
           else
              {TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumGrClass].AttGr;
               /*........ afficher la valeur numerique ...........*/
               FAST_CHARNCPY(pt_src, affi_buff, nb_car+1);
               PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
              }
           nb_car++;     /* tenir compte de l'introducteur  */
           /*........ avancer positions ...............*/
           pt_src            += nb_car;
           pos               += nb_car;
           
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
          /* KEYWORD */
       else if ( validTab[*pt_src]                && /* si IS_C_NAME(pt_src)  len = au minimum 1 */
                 BeforeIsValid(pt_src, i, validTab, TXT_A)
               ) 
          {KEY_WRD key_input, *key_result;
           nb_car           = CPY_STR_TO_TEST(pt_src, key_input.Name, (long)validTab);
           key_input.LenKey = nb_car;
           key_result       = (KEY_WRD*)bsearch(&key_input,
                                                 kwsection->KwAdr,
                                                 kwsection->NbKeyW,
                                                 sizeof(KEY_WRD),
                                                 NewKeyWordCompare
                                               );
           if (key_result)
              {/*........... afficher le texte avant .......................*/
               *pt_dst        = 0;
               PrintHTMLColorBaliseTxt(fh, TXT_A->AffiBuff, TXT_A); 
               /*........... afficher le texte du mot clef .................*/
               TXT_A->ATT_Cur = &syntprm->GrClass[key_result->GraphClass].AttGr;
               PrintHTMLColorBaliseTxt( fh, key_result->Name, TXT_A);
               /*........... si mot clef = fin de section ..................*/
               if (kwsection->MajMin & 4)
                  {isInkwSection      = 0;
                   kwsection          = &syntprm->KwSection[isInkwSection];
                   intGrClass         = kwsection->IntGrClass;
                   validTab           = kwsection->ValidChar;
                   beg_tab            = kwsection->BegSection;
                   end_tab            = kwsection->EndSection;
                  }
               TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
               pt_dst         = affi_buff;
              }
           else
              {
               /*FAST_CHARMEMCPY(pt_src, pt_dst, nb_car);*/
               memcpy(pt_dst, pt_src, nb_car); 
               pt_dst        += nb_car;
               /*tx            += PrintHTMLColorBaliseTxt( tx,  ty, key_input.Name, TXT_A);*/
              }
           pt_src   += nb_car;
           pos      += nb_car;
          }
       /* BEG SECTION */
       else if ( beg_tab[*pt_src] &&
                (nb_car = IsBegSection(pt_src, &isInSection, &idgrclass, isInkwSection, syntprm))
               )
          {/*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           pt_dst         = affi_buff;
           FAST_CHARMEMCPY(pt_src, pt_dst, nb_car);
           /*memcpy(pt_dst, pt_src, nb_car); */
           pt_dst        += nb_car;
           pt_src        += nb_car;
           pos           += nb_car;
          }
       /* BEG KW_SECTION */
       else if (isInkwSection == 0   &&
                kwbeg_tab[*pt_src]   &&
                (nb_car = IsBegKwSection(pt_src, &isInkwSection, &idgrclass, syntprm))
               )
          {
           /*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           /*........ afficher le delimiteur ...........*/
           FAST_CHARNCPY(pt_src, affi_buff, nb_car);
           /*memcpy(affi_buff, pt_src, nb_car); */
           /* affi_buff[nb_car] = 0;            */           
           PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           kwsection          = &syntprm->KwSection[isInkwSection];
           intGrClass         = kwsection->IntGrClass;
           
           pt_dst             = affi_buff;
           TXT_A->ATT_Cur     = &syntprm->GrClass[intGrClass].AttGr;
           pt_src            += nb_car;
           pos               += nb_car;
           
           validTab           = kwsection->ValidChar;
           beg_tab            = kwsection->BegSection;
           end_tab            = kwsection->EndSection;
          }
       /* END KW_SECTION */
       else if (isInkwSection       &&
                kwend_tab[*pt_src]  &&
                (nb_car = IsEndKwSection(pt_src, &isInkwSection, &idgrclass, syntprm))
               )
          {
           /*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           PrintHTMLColorBaliseTxt( fh, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           /*........ afficher le delimiteur ...........*/
           FAST_CHARNCPY(pt_src, affi_buff, nb_car);
           /*memcpy(affi_buff, pt_src, nb_car);*/
           /*affi_buff[nb_car]  = 0;           */
           PrintHTMLColorBaliseTxt( fh, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           kwsection          = &syntprm->KwSection[isInkwSection];
           intGrClass         = kwsection->IntGrClass;
           
           pt_dst             = affi_buff;
           TXT_A->ATT_Cur     = &syntprm->GrClass[intGrClass].AttGr;
           pt_src            += nb_car;
           pos               += nb_car;
           
           validTab           = kwsection->ValidChar;
           beg_tab            = kwsection->BegSection;
           end_tab            = kwsection->EndSection;
          }
       /* OPERATOR */
       else if ( (idgrclass = IS_C_OPP(pt_src, kwsection->Operator))
               )
          {/*........ afficher le texte avant ..........*/
           *pt_dst        = 0;
           PrintHTMLColorBaliseTxt( fh, affi_buff, TXT_A);
           /*........ afficher le '(' ..................*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           pt_dst         = affi_buff;
           *pt_dst++      = *pt_src++;
           pos++;
           /*.......... petite optimisation pour si suite pareille ..........*/
           while (                         /* SI espace ou operateur de meme couleur   */
                   (*pt_src==' '  ||
                    (idgrclass  == IS_C_OPP(pt_src, kwsection->Operator))
                   )
                  &&
                   (!kwend_tab[*pt_src] && /* et pas ne fin de section de mot clef     */
                    !kwbeg_tab[*pt_src] && /* et pas un debut de section de mot clef   */
                    !beg_tab[*pt_src]   && /* et pas un debut de section classique     */
                    !validTab[*pt_src]     /* et pas un debut de mot clef              */
                   )
                 )
              {*pt_dst++  = *pt_src++;
                pos++;
              }
           *pt_dst        = 0;
           PrintHTMLColorBaliseTxt( fh, affi_buff, TXT_A);
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
       else
          {*pt_dst++ = *pt_src++;
           pos++;
          }
      }
  }/* endwhile */
 *pt_dst   = 0;
 PrintHTMLColorBaliseTxt(fh, affi_buff, TXT_A);
 FwriteStr(fh, "\r\n");
 return 1;
#pragma warn .pia
}

/*-------------------------- PrintHTMLColorBaliseTxt ----------------------------*/
/* ACTION: affiche le contenu d'un buffer avec les attributs courants.       */
/* ENTREE: int tx, int ty: position d'affichage en pixels.                   */
/*         char *buft: chaine  afficher.                                    */
/*         TXTED_OB *TXT_A: structure de definition des parametres.          */
/* RETOUR: largeur de ce qui vient d'etre affiche.                           */

int PrintHTMLColorBaliseTxt(FILE* fh, char *PtTexteLigne, TXTED_OB *TXT_A)
{extern int EZ_font, EZ_point; /* declaree dans EAZY_GEM.C              */
 char* pt        = PtTexteLigne;
 char* str_html  = 0;
 
 if (*PtTexteLigne==0) return 0;
 /*.......... ecrire attributs texte ...............*/
 WriteAttributsTxtTAG(fh, TXT_A->ATT_Cur);
 /*........... ecrire le texte .....................*/
 while (*pt)
    {str_html  = CarToHTML_str(pt);
     FwriteStr(fh, str_html);
     pt++;
    }
 /*........... fermer les attributs texte ..........*/
 FwriteStr(fh, "</FONT>");
 return 1;
}    

/*------------------------------------ CarToHTML_str -------------------------*/
char* CarToHTML_str(char* pt)
{switch(*pt)
   {case '':  return "&agrave;";
    case '':  return "&egrave;";
    case '':  return "&igrave;";
    case '':  return "&ograve;";
    case '':  return "&ugrave;";
    /*case '':  return "&ygrave;";*/
    case '':  return "&Agrave;";
    /*case '':  return "&Egrave;";*/
    /*case '':  return "&Igrave;";*/
    /*case '':  return "&Ograve;";*/
    /*case '':  return "&Ugrave;";*/
    /*case '':  return "&Ygrave;";*/

    case '':  return "&acute;";
    case '':  return "&aacute;";
    case '':  return "&eacute;";
    case '':  return "&iacute;";
    case '':  return "&oacute;";
    case '':  return "&uacute;";
    /*case '':  return "&yacute;";*/
    /*case '':  return "&Aacute;";*/
    case '':  return "&Eacute;";
    /*case '':  return "&Iacute;";*/
    /*case '':  return "&Oacute;";*/
    /*case '':  return "&Uacute;";*/
    /*case '':  return "&Yacute;";*/
    
    case '':  return "&acirc;";
    case '':  return "&ecirc;";
    case '':  return "&icirc;";
    case '':  return "&ocirc;";
    case '':  return "&ucirc;";
    /*case '':  return "&ycirc;";*/
    /*case '':  return "&Acirc;";*/
    /*case '':  return "&Ecirc;";*/
    /*case '':  return "&Icirc;";*/
    /*case '':  return "&Ocirc;";*/
    /*case '':  return "&Ucirc;";*/
    /*case '':  return "&Ycirc;";*/

    case '':  return "&auml;";
    case '':  return "&euml;";
    case '':  return "&iuml;";
    case '':  return "&ouml;";
    case '':  return "&uuml;";
    case '':  return "&yuml;";
    case '':  return "&Auml;";
    /*case '':  return "&Euml;";*/
    /*case '':  return "&Iuml;";*/
    case '':  return "&Ouml;";
    case '':  return "&Uuml;";
    /*case '':  return "&Yuml;";*/
    
    case '"':  return "&quot;";
    case '&':  return "&amp;";
    /*case ' ':  return "&nbsp;";*/
    case '':  return "&ccedil;";
    case '':  return "&Ccedil;";
    
    case '<':  return "&lt;";
    case '>':  return "&gt;";
    case '|':  return "&brvbar;";
    case '':  return "&copy;";
    case '':  return "&reg;";
    case '':  return "&ordm;";
    case '':  return "&fraq12;";
    case '':  return "&fraq14;";
    case '':  return "&sup2;";
    case '':  return "&sup3;";
    case '':  return "&uml;";
    case '':  return "&times;";
    case '':  return "&oslash;";
    case '':  return "&eth;";
    default:   return memcpy(" ", pt, 1);
   }
}
   
/*------------------- WriteAttributsTxtTAG ----------------------------------------*/
int WriteAttributsTxtTAG(FILE* fh, CAR_ATTR*  attCur)
{char rgbstr[128];
 char buft[64];
 int  rgb[3];
 char *pt      = rgbstr;
 long len_num  = 0;

 /*.................. <FONT COLOR="#FF0000"> ............................*/
 FwriteStr(fh,"<FONT COLOR=\"#");
 vq_color( VDIhandle, attCur->CarCol, 1, rgb );
 itoa(rgb[0]>>2, buft, 16);
 len_num = strlen(buft);
 if (len_num<2) {strcpy(pt,"0"); strcpy(pt+1, buft); pt+=2;}
 else           {strcpy(pt, buft+len_num-2);         pt+=2;}
 itoa(rgb[1]>>2, buft, 16);
 len_num = strlen(buft);
 if (len_num<2) {strcpy(pt,"0"); strcpy(pt+1, buft); pt+=2;}
 else           {strcpy(pt, buft+len_num-2);         pt+=2;}
 itoa(rgb[2]>>2, buft, 16);
 len_num = strlen(buft);
 if (len_num<2) {strcpy(pt,"0"); strcpy(pt+1, buft); pt+=2;}
 else           {strcpy(pt, buft+len_num-2);         pt+=2;}
 fwrite(rgbstr, strlen(rgbstr), 1, fh);
 fwrite("\">", 2, 1, fh);
 return 16 + (int)strlen(rgbstr);
 
}
/*----------------------- FwriteStr ------------------------------------------------*/
void FwriteStr(FILE* fh, char *str)
{fwrite(str, strlen(str), 1, fh);
}
